import pygame
from random import *
from math import *
from Numeric import *


bugimages = (pygame.image.load("darkbug.bmp"),pygame.image.load("lightbug.bmp"))


class Bug(pygame.sprite.Sprite):
   def __init__(self,team,x,y,attack,defense,move,power,style):
      pygame.sprite.Sprite.__init__(self)
      if team==1:
         self.image = bugimages[1]
      else:
         self.image = bugimages[0]
      self.image.set_colorkey([192,192,192])
      self.rect = self.image.get_rect()
      self.rect.center = (x,y)
      self.team=team
      self.bugx=x
      self.bugy=y
      self.attack=attack
      self.defense=defense
      self.move=move
      self.power=power
      self.style=style
      self.energy=110
      self.health=20
      self.pred_burst=0
      self.panicked=0
      self.parthunting=0
      self.command=0
      self.commandx=0
      self.commandy=0
      self.command2=0
      self.command3=0  


   def update(self,objects,distbugs):
      distobj = zeros((len(objects),2))
      for c in range (0,len(objects)):
         distobj[c][0]=abs(objects[c].objectx-self.bugx)+abs(objects[c].objecty-self.bugy) 
         distobj[c][1]=objects[c].object_type

      if self.energy>0: 
         self.bugx=self.bugx+randint(1,3)-2
         self.bugy=self.bugy+randint(1,3)-2
      else:
         self.health=-1
      if self.power==1 and randint(1,100)<25:
         self.energy = self.energy-1
      if self.power==2 and randint(1,100)<15:
         self.energy = self.energy-1
      if self.power==3 and randint(1,100)<5:
         self.energy = self.energy-1


      self.position= (self.bugx,self.bugy)
      self.rect = self.image.get_rect()
      self.rect.center = self.position

            
         



class Object:
   def __init__(self,object_type,object_rating,objectx,objecty):
      self.object_type = object_type
      self.object_rating = object_rating
      self.objectx = objectx
      self.objecty = objecty
      if self.object_type==1:
         self.color=(self.object_rating*15,0,0)
      if self.object_type==2:
         self.color=(0,0,self.object_rating*15)
      if self.object_type==3:
         self.color=(self.object_rating*15,self.object_rating*15,0)
      if self.object_type==4:
         self.color=(0,self.object_rating*15,0)
      if self.object_type==5:
         if self.object_rating<5:
            self.color=(50,0,50)
         if self.object_rating<10:
            self.color=(150,0,150)
         if self.object_rating>9:
            self.color=(250,0,250)
      if self.object_type==6:
            self.color=(0,object_rating*15,object_rating*15)
   def update(self):
      return self.objectx,self.objecty
      
class Daytime:
   def __init__(self,duration,maxday,minday,direction):
      self.daylength=maxday+minday
      self.duration = duration
      self.noon= (maxday+minday)/2
      self.maxday= maxday
      self.minday= minday
      self.direction = direction
      self.now = randint(1,duration)
   
   def time(self):
      sunrise = self.noon - (self.duration/2)
      sunset= self.noon + (self.duration/2)
      if self.now > sunset or self.now < sunrise:
         light = 0
      else:
         if self.now >= sunrise and self.now < self.noon:
            light = (100*(self.now-sunrise))/(self.noon-sunrise)
         else:
            light = (100*(sunset-self.now)/(self.noon-sunrise))
      if self.now == self.noon:
         light = 100
      return light

   def click(self):
      self.now = self.now + 1
      if self.daylength == self.now:
         self.now = 0
         self.duration = self.duration + self.direction
      if self.duration >= self.maxday:
         self.direction = -1
      if self.duration <= self.minday:
         self.direction = 1

   def season(self):
      if self.duration >= self.daylength/2 and self.direction == 1:
         seasonis = "Spring"
      if self.duration >= self.daylength/2 and self.direction == -1:
         seasonis = "Summer"
      if self.duration < self.daylength/2 and self.direction == -1:
         seasonis = "Fall"
      if self.duration < self.daylength/2 and self.direction == 1:
         seasonis = "Winter"
      return seasonis        
  
      
      
